/*
 * Copyright(c) 2007 Intel Corporation. All rights reserved.
 * Copyright(c) 2008 Mellanox Technologies. All rights reserved.
 *
 * This software is available to you under the terms and conditions of the GNU
 * General Public License (GPL) Version 2, as published by the Free Software 
 * Foundation.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef FC_ACCEL_H
#define FC_ACCEL_H

#include <scsi/scsi_cmnd.h>

struct fc_accel_dev_ops {
	void (*clean_exch)(void *priv, struct scsi_cmnd *cmd, int xno);
	int (*do_scsi_send)(void *priv, struct fc_scsi_pkt *fsp);
	int (*do_send)(void *priv, int channel, struct sk_buff *skb, u8 fceof);
	int (*flogi_finished)(struct fcdev *fc_dev);
};

struct fc_accel_dev {
	struct fc_accel_dev_ops accel_ops;
	struct fcdev *fdev;
	void *drv_priv;
};

struct fc_accel_dev *mlx4_alloc_openfc(struct fc_accel_dev_ops, int);
int mlx4_init_openfc(struct fcdev *fdev, int auto_start);
void mlx4_destroy_openfc(struct fcdev *fdev);
int mlx4_fc_rcv(struct fcdev *fdev, struct sk_buff *skb);
int mlx4_fc_init_rx(void);
void mlx4_fc_kill_rx(void);

#endif
