#!/bin/bash
# Usage: ofed_checkout.sh <branch>

# Execute command w/ echo and exit if it fail
ex()
{
        echo "$@"
        eval "$@"
        if [ $? -ne 0 ]; then
                printf "\nFailed executing $@\n"
                exit 1
        fi
}

ex git checkout $1 `git-ls-tree -r --name-only $1 \
        kernel_addons \
        `
ex git checkout $1 `git-ls-tree -r --name-only $1 \
	ofed_scripts \
	mlnx_en_scripts \
	kernel_patches/fixes/ \
	mlnx_en_patches/ \
	kernel_patches/backport/ \
        drivers/net/mlx4 \
        drivers/infiniband/hw/mlx4 \
	drivers/infiniband/debug/ \
        include/linux/mlx4 \
        include/rdma/ib_umem.h \
        include/rdma/ib_verbs.h \
        kernel/kfifo.c \
        lib/klist.c \
        `
ex git update-ref HEAD $1

